$MOD51
$TITLE(DT51 I2C ADDA)
;------------------
;ALAMAT PROSEDUR LCD
;------------------
Write          		EQU     0700H
InitLCD         	EQU     0740H
CommandLCD	     	EQU     07B0H
WriteLCD        	EQU     07D0H
ReadLCD         	EQU     07F0H
ReadAddrLCD     	EQU     0820H
SetDDRAM        	EQU     0850H
SetCGRAM        	EQU     0870H
;-----------
;PERINTAH LCD
;-----------
DisplayClear	        EQU	01H
CursorHome	        EQU	02H
ShiftCursorRight        EQU	14H
ShiftCursorLeft		EQU	10H
ShiftDisplayRight	EQU	1CH
ShiftDisplayLeft	EQU	18H
DShiftCursorInc		EQU	07H
DShiftCursorDec		EQU	05H

;----------
;KONSTANTA
;----------
Simbol		EQU	20H

		CSEG
		ORG	4000H
		LJMP	Start

		ORG	4100H
		$NOLIST
		$INCLUDE(ADDA.ASM)
		$LIST

Delay:		PUSH	02H
		PUSH	03H
		MOV	R2,#0FFH
Del:		MOV	R3,#0FFH
		DJNZ	R3,$
		DJNZ	R2,Del
		POP	03H
		POP	02H
		RET		
		

;----------------
;TAMPILKAN KE LCD
;----------------
;               ----------------
;               Display at Line1
;               ----------------
BARIS1:
	        MOV     A,#00H
                LCALL   SetDDRAM
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'R'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'C'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#'D'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

TEGANGAN:	
		MOV     A,#0FH
                LCALL   SetDDRAM

		MOV	A,R6
		MOV	B,#100
		DIV	AB	
		ADD	A,#48
		LCALL	WriteLCD
		
		PUSH	ACC
		MOV	A,#'.'
		LCALL	WriteLCD	
		POP	ACC
		
		MOV	A,B
		MOV	B,#10
		DIV	AB	
		ADD	A,#48
		LCALL	WriteLCD

		MOV	A,B
		ADD	A,#48
		LCALL	WriteLCD				
	
		PUSH	ACC
		MOV	A,#' '
		LCALL	WriteLCD	
		MOV	A,#'V'
		LCALL	WriteLCD	
		MOV	A,#'O'
		LCALL	WriteLCD	
		MOV	A,#'L'
		LCALL	WriteLCD	
		MOV	A,#'T'
		LCALL	WriteLCD	
		POP	ACC
		RET

;               ----------------
;               Clear at Line 2
;               ----------------
HAPUS_BARIS2:		
		MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		
		RET

Start:		MOV	P1,#0FFH
		MOV	SP,#40H
		MOV	Flag,#00H
		MOV	Ch0,#00H
		MOV	Ch1,#00H
		MOV	Ch2,#00H
		MOV	Ch3,#00H

		MOV	R0,#00H
		MOV	R1,#00H
		MOV	R2,#00H
		MOV	R3,#00H
		MOV	R4,#00H
		MOV	R5,#00H
		MOV	R6,#00H
		MOV	R7,#00H

		LCALL	InitLCD			;Init LCD
		MOV	A,#DisplayClear
		LCALL	CommandLcd
		MOV	A,#0Ch
		LCALL	CommandLcd
		
		ACALL	BARIS1			;Display LCD
		LJMP	Star

Starting:	MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#'S'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'R'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#'G'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'W'
		LCALL	WriteLCD
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

Bersih:		MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'P'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'U'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

Rendah:		MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'W'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'P'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'U'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

Medium:		MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#'M'
		LCALL	WriteLCD
		MOV	A,#'E'
		LCALL	WriteLCD
		MOV	A,#'D'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'P'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'U'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

Tinggi:		MOV     A,#40H
                LCALL   SetDDRAM
		MOV	A,#'H'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'G'
		LCALL	WriteLCD
		MOV	A,#'H'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'P'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'U'
		LCALL	WriteLCD
		MOV	A,#'T'
		LCALL	WriteLCD
		MOV	A,#'I'
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		RET

;-------------------
;  Start awal
;-------------------

Star:		MOV	R0,#255
		MOV	R1,#255
		MOV	R2,#255
		MOV	Simbol,#150
Star1:		LCALL	Starting
		LCALL	Delay
		LCALL	HAPUS_BARIS2
		LJMP	Krng
		
Awal1:		LCALL	Bersih
		LCALL	Delay
		MOV	Mode,#0			;Mode=0
		MOV	Channel,#0		;Ch=0
		SETB	AutoInc				

		MOV	A,#00H			;Slave Addr=0		
		LCALL	InitADDA		;Init ADDA
		JB	InitDone,Back
		CLR	P1.0			;Indicate init fail
		AJMP	$
		
Back:		LCALL	ReadADC
		MOV	A,CH0
		CJNE	A,Simbol,Lakukan	;Bandingkan A dengan simbol

Lakukan:	JNC	Awal2
		MOV	Simbol,A
		JMP	Awal1		

Awal2:		CLR	C
		SUBB	A,Simbol		;A=A-Simbol
		PUSH	ACC
		MOV	R6,A
		LCALL	Tegangan
		LCALL	Delay
		POP	ACC
		CJNE	A,#3,Stabil

Stabil:		JC	Stab
		CJNE	A,#40,Maju

Maju:		JC	Awal1			;A<#40 -->Back
		CJNE	A,#50,Maju1

Maju1:		JC	Satu			;A<#50  -->Satu
		CJNE	A,#60,Maju2

Maju2:		JC	Dua		;A<#60  -->Dua
		LJMP	Tiga		;A>#60  -->Tiga	

Krng:		DEC	R0
		CJNE	R0,#0,Star1
		MOV	R0,#4		
		DEC	R1
		CJNE	R1,#0,Star1a
		LJMP	Awal1

Stab:		DEC	R2
		CJNE	R2,#0,Awal1
		CLR	C
		ADD	A,Simbol
		MOV	Simbol,A	
		MOV	R2,#255
		LJMP	Awal1

Star1a:		LJMP	Star1

;-----------------
; Low Polution
;-----------------

Satu:		MOV	R0,#200
		MOV	R1,#10
Awl:		LCALL	Rendah
		LCALL	Delay  
		MOV	Mode,#0			;Mode=0
		MOV	Channel,#0		;Ch=0
		SETB	AutoInc				

		MOV	A,#00H			;Slave Addr=0		
		LCALL	InitADDA		;Init ADDA
		JB	InitDone,Back1
		CLR	P1.0			;Indicate init fail
		AJMP	$	
	
Back1:		LCALL	ReadADC
		MOV	A,CH0

		CJNE	A,Simbol,Depan

Depan:		JNC	Depan1			;A>Simbol  -->Depan1  
		MOV	Simbol,A

Depan1:		CLR	C
		SUBB	A,Simbol
		PUSH	ACC
		MOV	R6,A
		LCALL	Tegangan
		LCALL	Delay
		POP	ACC

		CJNE	A,#40,Depan2

Depan2:		JC	Kurang		;A<#40 -->Kurang
		CJNE	A,#50,Maj1

Maj1:		JC	Satu		;A<#50  -->Satu	
		CJNE	A,#60,Maj2

Maj2:		JC	Dua		;A<#60  -->Dua
		LJMP	Tiga		;A>#60  -->Tiga	


Kurang:		DEC	R0			;-------------------
		CJNE	R0,#0,Awl		;  Proses Looping
		MOV	R0,#1			;	&
		DEC	R1			; Pengambilan Data
		CJNE	R1,#0,Awl		;
		LJMP	Awal1			;-------------------

;------------------
; Medium Polution
;------------------

Dua:		MOV	R0,#200
		MOV	R1,#15
Bwl:		LCALL	Medium
		LCALL	Delay
		MOV	Mode,#0			;Mode=0
		MOV	Channel,#0		;Ch=0
		SETB	AutoInc				

		MOV	A,#00H			;Slave Addr=0		
		LCALL	InitADDA		;Init ADDA
		JB	InitDone,Back2
		CLR	P1.0			;Indicate init fail
		AJMP	$	

Back2:		LCALL	ReadADC
		MOV	A,CH0

		CJNE	A,Simbol,Muka
Muka:		JNC	Muka1		;A>Simbol  -->Muka1 
		MOV	Simbol,A	;A<Simbol  maka A --> Simbol

Muka1:		CLR	C
		SUBB	A,Simbol
		PUSH	ACC
		MOV	R6,A
		LCALL	Tegangan
		LCALL	Delay
		POP	ACC
		CJNE	A,#50,Muka2

Muka2:		JC	Kurang1		;A<#50  --->kurang1
		CJNE	A,#60,Majs

Majs:		JC	Dua		;A<#60  -->Dua
		LJMP	Tiga		;A>#60  -->Tiga

Kurang1:	DEC	R0			;-------------------
		CJNE	R0,#0,Bwl		;  Proses Looping
		MOV	R0,#1			;	&
		DEC	R1			; Pengambilan Data
		CJNE	R1,#0,Bwl		;
		LJMP	Awl			;-------------------

;----------------
; High Polution
;----------------

Tiga:		MOV	R0,#220
		MOV	R1,#15
Cwl:		LCALL	Tinggi
		LCALL	Delay
		MOV	Mode,#0			;Mode=0
		MOV	Channel,#0		;Ch=0
		SETB	AutoInc				

		MOV	A,#00H			;Slave Addr=0		
		LCALL	InitADDA		;Init ADDA
		JB	InitDone,Back3
		CLR	P1.0			;Indicate init fail
		AJMP	$	

Back3:		LCALL	ReadADC
		MOV	A,CH0

		CJNE	A,Simbol,Akhir

Akhir:		JNC	Akhir1			;A>Simbol  -->Akhir1 
		MOV	Simbol,A		;A<Simbol  maka A --> Simbol

Akhir1:		CLR	C
		SUBB	A,Simbol
		PUSH	ACC
		MOV	R6,A
		LCALL	Tegangan
		LCALL	Delay
		POP	ACC
		CJNE	A,#60,Akhir2

Akhir2:		JC	Kurang2			;A<#60 --> Kurang2
		LJMP	Tiga			;A>#60 --> Tiga

Kurang2:	DEC	R0			;-------------------
		CJNE	R0,#0,Cwl		;  Proses Looping
		MOV	R0,#1			;	&
		DEC	R1			; Pengambilan Data
		CJNE	R1,#0,Cwl		;
		LJMP	Bwl			;-------------------


		END




	

